`timescale 1ns / 1ps


module test_stepper_motor_uni;

	// Inputs
	reg clk;
	reg rstb;
	reg start;
	reg en;
	reg cw;
	reg [3:0]step_t;
	reg [7:0]step_n;

	// Outputs
	wire busy;
	wire m_a;
	wire m_a_b;
	wire m_b;
	wire m_b_b;


parameter p_clk_period = 20 ;//CLK=50MHẑƂ1ms̃JEgl
	// Instantiate the Unit Under Test (UUT)
	stepper_motor_uni uut (
		.clk(clk), 
		.rstb(rstb), 
		.start(start),  
		.en(en), 
		.cw(cw),  
		.step_t(step_t),  
		.step_n(step_n),  
		.busy(busy),
		.m_a(m_a),
		.m_a_b(m_a_b),
		.m_b(m_b),
		.m_b_b(m_b_b)
	);

        initial begin
                // Initialize Inputs
                repeat(100000000)begin
                  clk = 0;
                  #(p_clk_period/2);
                  clk = 1;
                  #(p_clk_period/2) ;
           end
        end
		
	initial begin
		// Initialize Inputs
		rstb = 0;
		step_n = 8;
		step_t = 0;
		start = 1;
		cw = 1;
		en = 0;
		// Wait 100 ns for global reset to finish
		#(p_clk_period*5);
		rstb = 1;
		#(p_clk_period*5);
		en = 1;
		repeat(3) begin
		  #(p_clk_period*5);
		  start = 0;
		  #(p_clk_period*5);
		  start = 1;
		  #(p_clk_period*5000000);
		  step_t = step_t + 1;
		end
		#(p_clk_period*5);
		start = 0;
		#(p_clk_period*5);
		start = 1;
		#(p_clk_period*5000000);
		#50000000;
		step_t = 15;
		#(p_clk_period*5);
		start = 0;
		#(p_clk_period*5);
		start = 1;
		#(p_clk_period*10000000);
		step_t = 2;
		#(p_clk_period*5);
		start = 0;
		#(p_clk_period*5);
		start = 1;
		#(p_clk_period*15000000);
		cw = 0;
		#(p_clk_period*5);
		start = 0;
		#(p_clk_period*5);
		start = 1;
		#(p_clk_period*15000000);
		cw = 1;
		$stop;
        
		// Add stimulus here

	end
      
endmodule

